"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.flattenDeep = void 0;
const _reduceLazy_1 = require("./_reduceLazy");
const purry_1 = require("./purry");
function flattenDeep() {
    return (0, purry_1.purry)(_flattenDeep, arguments, flattenDeep.lazy);
}
exports.flattenDeep = flattenDeep;
function _flattenDeep(items) {
    return (0, _reduceLazy_1._reduceLazy)(items, flattenDeep.lazy());
}
function _flattenDeepValue(value) {
    if (!Array.isArray(value)) {
        return value;
    }
    const ret = [];
    for (const item of value) {
        if (Array.isArray(item)) {
            ret.push(...flattenDeep(item));
        }
        else {
            ret.push(item);
        }
    }
    return ret;
}
(function (flattenDeep) {
    flattenDeep.lazy = () => (value) => {
        const next = _flattenDeepValue(value);
        return Array.isArray(next)
            ? { done: false, hasNext: true, hasMany: true, next }
            : { done: false, hasNext: true, next };
    };
})(flattenDeep || (exports.flattenDeep = flattenDeep = {}));
