import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function flattenDeep() {
    return purry(_flattenDeep, arguments, flattenDeep.lazy);
}
function _flattenDeep(items) {
    return _reduceLazy(items, flattenDeep.lazy());
}
function _flattenDeepValue(value) {
    if (!Array.isArray(value)) {
        return value;
    }
    const ret = [];
    for (const item of value) {
        if (Array.isArray(item)) {
            ret.push(...flattenDeep(item));
        }
        else {
            ret.push(item);
        }
    }
    return ret;
}
(function (flattenDeep) {
    flattenDeep.lazy = () => (value) => {
        const next = _flattenDeepValue(value);
        return Array.isArray(next)
            ? { done: false, hasNext: true, hasMany: true, next }
            : { done: false, hasNext: true, next };
    };
})(flattenDeep || (flattenDeep = {}));
