import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function intersectionWith() {
    return purry(_intersectionWith, arguments, intersectionWith.lazy);
}
function _intersectionWith(array, other, comparator) {
    const lazy = intersectionWith.lazy(other, comparator);
    return _reduceLazy(array, lazy);
}
(function (intersectionWith) {
    intersectionWith.lazy = (other, comparator) => (value) => other.some((otherValue) => comparator(value, otherValue))
        ? { done: false, hasNext: true, next: value }
        : { done: false, hasNext: false };
})(intersectionWith || (intersectionWith = {}));
